/**
 * @authorAnn
 * wizard, 
 * defines pages' sequence and initial/finish functions
 */
package org.cvo.fithas.ui.configure;

import java.io.IOException;

import org.cvo.fithas.exception.NotSpecifiedInfoException;
import org.cvo.fithas.util.DBConfHelper;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.wizard.Wizard;

public class ConfigDBWizard extends Wizard {
	
	static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(ConfigDBWizard.class.getName () ) ;

    private ConfigDBPage configDBPage;//ҳһWizardPage

    
    /**
     * дaddPagesڴ˷1ҳ벢
     */
    public void addPages() {
        //ҳ󣬲ҳ
    	configDBPage = new ConfigDBPage("config db");        
        //WizardPage˳ڽʾ˳
        addPage(configDBPage);        
    }

    
    /**
     * дcanFinishɴ˷жϡɡťʱá
     * Ϊûһҳʱɡť
     * Will add soon: page seq-- to identify backward and forward, 
     * 		avoiding no update when try again as well as frequent calling "canFinish".
     *  And also: clear actions when go backward.
     *  
     * @return falseɡťãtrue෴
     */
    public boolean canFinish() {    	
        return super.canFinish();
    }

    
   
	/**
     * дperformFinishɡťʱִд˷
     * wizard dialog will be close, and left the main shell
     */
    public boolean performFinish() {
    	//write back to properties file
        try {
        	configDBPage.saveInConnInfo();
        	DBConfHelper.saveAttribute(configDBPage.getConnInfo());
		} catch (IOException e) {
			e.printStackTrace();
			String msg = e.getMessage()==null? "IOException occured" : e.getMessage();
			MessageDialog.openError(null, "", msg);
		} catch (NotSpecifiedInfoException e) {
			e.printStackTrace();
			String msg = e.getMessage()==null? "Exception occured." : e.getMessage();
			MessageDialog.openError(null, "", msg);
		}
        return true;

    }


}