package org.cvo.fithas.ui.wizard.headerarchiving;

import java.io.IOException;

import org.cvo.fithas.ui.wizard.ResultPage;
import org.cvo.fithas.util.ConfigHelper;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

public class ArchiveResultPage extends ResultPage {

	static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(ArchiveResultPage.class.getName () ) ;
	
	
	private String resultMsg ="";
	private Label resultLabel = null;

//    private CreateTableTask task = new CreateTableTask(this); //CreateTableTaskΪ̨
//    private ProgressBar progressBar;//
    private Text detailText;//Ϣı
	
    protected ArchiveResultPage(String pageName) {
        super(pageName);
    }

    public void createControl(Composite parent) {
        //һĵײ壬ʹGridLayout
        Composite container = new Composite(parent, SWT.NULL);
        container.setLayout(new GridLayout());
        
        try {
	        //message label
	        resultLabel = new Label(container, SWT.NONE);
	        final GridData gridData = new GridData(SWT.FILL, SWT.CENTER, false, false);
	        gridData.widthHint = 460;
	        gridData.heightHint = 30;
	        resultLabel.setLayoutData(gridData);
	        resultLabel.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.result.progressing"));
        
	        final Composite composite = new Composite(container, SWT.NONE);
	        composite.setLayoutData(new GridData(497, 330));
	        composite.setLayout(new GridLayout());

	        final Label detailLabel = new Label(composite, SWT.NONE);
	        detailLabel.setLayoutData(new GridData(132, SWT.DEFAULT));
	        detailLabel.setText(ConfigHelper.getAttribute("ui.msg.wizard.archive.result.detail"));

	        //Ϣı
	        detailText = new Text(composite, SWT.V_SCROLL | SWT.MULTI | SWT.BORDER | SWT.WRAP);
	        final GridData gridData_1 = new GridData(SWT.FILL, SWT.FILL, false, false);
	        gridData_1.widthHint = 460;
	        gridData_1.heightHint = 200;
	        detailText.setLayoutData(gridData_1);
	        detailText.setCapture(true);
	        detailText.setEditable(false);
	        
        	//ÿҳʾϢ
			setTitle(ConfigHelper.getAttribute("ui.msg.wizard.archive.result.title"));
//  		setMessage("ѧУ", INFORMATION);
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

        //Ҫһ
        this.setControl(container);      
       
    }
    
    /*
     * --------Ӧset/get ---------------
     */

	
	/**
	 * @return Returns the resultMsg.
	 */
	public String getResultMsg() {
		return resultMsg;
	}

	/**
	 * @param resultMsg The resultMsg to set.
	 */
	public void setResultMsg(String resultMsg) {
		this.resultMsg = resultMsg;
		resultLabel.setText(resultMsg);
		logger.debug("--result is:"+resultMsg);
		
	}

	/**
	 * @return Returns the detailText.
	 */
	public Text getDetailText() {
		return detailText;
	}
	
	/**
	 * @param detailText The detailText to set.
	 */
	public void setDetailText(Text detailText) {
		this.detailText = detailText;
	}  
	
	/**
     * Append text in the detailText field.
     * */
    public void appendDetailText(String string) {
    	detailText.insert(string+"\n");
	}
    
	/**
     * Clear text in the detailText field.
     * */
    public void clearDetailText() {
    	this.detailText.setText("");
	}
}