/**
 * @author: Ann
 * used in wizard , mainly in CreateTableWizard and ArchivingWizard
 * more files can be selected(file dialog and dir dialog)
 * CreateTableWizard MAY NEED TO CHOOSE INTERSET OR UNION? USE ANOTHER PAGE?
 */
package org.cvo.fithas.ui.wizard.headerarchiving;

import java.io.IOException;

import org.cvo.fithas.ui.wizard.MyWizardPage;
import org.cvo.fithas.util.ConfigHelper;
import org.cvo.fithas.util.SystemConstant;
import org.cvo.fithas.util.Utils;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Spinner;
import org.eclipse.swt.widgets.Text;

public class FileNameFilterPage extends MyWizardPage {
	
	private Combo extName; //file name extension
	
	private Combo includes;
	
	private Text literalText;
	private Combo availableCharsCombo;
	private Text regExp;
	private Text fileName;
	private Spinner spinnerMax;
	private Spinner spinnerMin;
	private Button unlimitedButton; //checkbox
	private String contains;
	
	
	
	static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(FileNameFilterPage.class.getName () ) ;
	
    
    /**
     * ̳иĹ캯
     */
    protected FileNameFilterPage(String pageName) {
        super(pageName);
    }

    /*
     * дcreateControlڴ˷ﹹҳϵĽעⲻҪ
     * parentֱӴԪأӦһtopCompϴ
     */
    public void createControl(Composite parent) {
    	
        //һĵײ壬ʹGridLayout
        Composite topComp = new Composite(parent, SWT.NULL);
        topComp.setLayout(new GridLayout());
        topComp.setBounds(20,20,380,220);
        
        
        
        try {

	        final Group fileNamePatternGroup = new Group(topComp, SWT.NONE);
	        fileNamePatternGroup.setText(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.namefilter.label.pattern"));
	        fileNamePatternGroup.setLayoutData(new GridData(456, 45));
	        
	        includes = new Combo(fileNamePatternGroup, SWT.NONE);
	        includes.setBounds(20, 27, 100, 30);
	        initIncludesNames(); //ʼõչб
	        
//	        regExp = new Text(fileNamePatternGroup, SWT.BORDER);
//	        regExp.setBounds(130, 27, 200, 23);
	        fileName = new Text(fileNamePatternGroup, SWT.BORDER);
	        fileName.setBounds(130, 27, 200, 23);

//	        extName = new Combo(fileNamePatternGroup, SWT.NONE);
//	        extName.setBounds(340, 27, 115, 30);
//	        initExtNames(); //ʼõչб

        final Composite composite = new Composite(topComp, SWT.NONE);
        final RowLayout rowLayout = new RowLayout();
        rowLayout.justify = true;
        composite.setLayout(rowLayout);
        final GridData gridData = new GridData(SWT.CENTER, SWT.CENTER, false, false);
        gridData.widthHint = 465;
        composite.setLayoutData(gridData);

        
	        //insert button, click to append chars to the pattern
     
		        //use char-auto-generation functions 
	        final Group advancedGroup = new Group(topComp, SWT.NONE);
	        advancedGroup.setLayoutData(new GridData(458, 160));
	        advancedGroup.setText(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.namefilter.label.advance"));
		        
		        //list of available characters(function characters)
	        final Label insertCharsLabel = new Label(advancedGroup, SWT.NONE);
	        insertCharsLabel.setBounds(10, 27,98, 20);
	        insertCharsLabel.setText(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.namefilter.label.charselect"));

	        availableCharsCombo = new Combo(advancedGroup, SWT.NONE | SWT.READ_ONLY);//ֻ
	        availableCharsCombo.setBounds(111, 24,253, 20);
	        availableCharsCombo.addSelectionListener(new SelectionListener(){
					public void widgetSelected(SelectionEvent arg0) {
						changeTextStatus(availableCharsCombo);					
					}
					public void widgetDefaultSelected(SelectionEvent arg0) {
						// TODO Auto-generated method stub					
					}
	        	
	        });

	        literalText = new Text(advancedGroup, SWT.BORDER);
	        literalText.setBounds(370, 22, 84, 23);
		        
		        
		        //minimum Amount
	        final Label minimumAmountLabel = new Label(advancedGroup, SWT.NONE);
	        minimumAmountLabel.setBounds(10, 54,85, 18);
	        minimumAmountLabel.setText(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.namefilter.min"));

	        spinnerMin = new Spinner(advancedGroup, SWT.BORDER);
	        spinnerMin.setSelection(1);
	        spinnerMin.setBounds(111, 52,46, 17);
		        
		        //maximum Amount
	        final Label maximunAmountLabel = new Label(advancedGroup, SWT.NONE);
	        maximunAmountLabel.setBounds(10, 83, 89, 22);
	        maximunAmountLabel.setText(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.namefilter.max"));

	        spinnerMax = new Spinner(advancedGroup, SWT.BORDER);
	        spinnerMax.setSelection(1);
	        spinnerMax.setBounds(111, 80,46, 17);
		        
		        //max - unlimited
	        unlimitedButton = new Button(advancedGroup, SWT.CHECK);
	        unlimitedButton.setBounds(184, 78,94, 23);
	        unlimitedButton.setText(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.namefilter.unlimited"));
	        unlimitedButton.addSelectionListener(new SelectionAdapter() {
	        	public void widgetSelected(final SelectionEvent e) {
	        		changeMaxStatus(unlimitedButton.getSelection());
	        	}

	        });
	        
	        final Button insertButton = new Button(advancedGroup, SWT.NONE);
	       // final RowData rowData_1 = new RowData();
//	        rowData_1.width = 112;
//	        insertButton.setLayoutData(rowData_1);
	        insertButton.setBounds(40, 110,94, 23);
	        insertButton.addSelectionListener(new SelectionAdapter() {
	        	public void widgetSelected(final SelectionEvent e) {
	        		String reg = makeRegExp();
	        		regExp.append(reg==null? "" : reg);
	        	}

	        });
	        insertButton.setText(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.namefilter.button.insert"));

	        final Button helpButton = new Button(advancedGroup, SWT.NONE);
	        helpButton.setBounds(180, 110,94, 23);
//	        final RowData rowData = new RowData();
//	        rowData.width = 112;
//	        helpButton.setLayoutData(rowData);
	        helpButton.addSelectionListener(new SelectionAdapter() {
	        	public void widgetSelected(final SelectionEvent e) {
	        		try {
							MessageDialog.openInformation(null, "about regular expressions", 
									ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.namefilter.howto"));
						} catch (IOException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
	        	}
	        });
	        helpButton.setText(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.namefilter.button.help"));

	        
	        regExp = new Text(advancedGroup, SWT.BORDER);
	        regExp.setBounds(40, 140, 200, 23);
	        
	        extName = new Combo(advancedGroup, SWT.NONE);
	        extName.setBounds(255, 140, 120, 30);
	        initExtNames(); //ʼõչб
	        
	        //init radio selection status
	        initStatus(); //enable file method
	        
	        //---ÿҳʾϢ---
			setTitle(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.namefilter.title"));
	        setMessage(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.namefilter.message"),
	        		INFORMATION);
	        
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

        //Ҫһ
        this.setControl(topComp);
        
    }


    private void initExtNames() {
        	int len = SystemConstant.REG_FILENAME_EXTENSION.length; //ѡչ        	
        	for(int i=0; i<len; i++)
        	{
        		extName.add(SystemConstant.REG_FILENAME_EXTENSION_COMMENT[i]); //text to show
        		extName.setData(""+i, SystemConstant.REG_FILENAME_EXTENSION[i]); //key(here use index) - data(actual value)
        		logger.debug("add file extention name: " +SystemConstant.REG_FILENAME_EXTENSION[i]);
        	}
        	extName.select(0);//ѡһ
    	}
    
    private void initIncludesNames() {
    	int len = SystemConstant.REG_MATCH_PATTERNS.length; //ѡչ        	
    	for(int i=0; i<len; i++)
    	{
    		includes.add(SystemConstant.REG_MATCH_PATTERNS[i]); //text to show
    		includes.setData(""+i, SystemConstant.REG_MATCH_PATTERNS[i]); //key(here use index) - data(actual value)
    		logger.debug("add match patters:: " +SystemConstant.REG_MATCH_PATTERNS[i]);
    	}
    	includes.select(0);//ѡһ
	}
    

	private void initTokenList() {
    	int len = SystemConstant.REG_CHARS.length; //ѡַ
    	
    	for(int i=0; i<len; i++)
    	{
    		availableCharsCombo.add(SystemConstant.REG_CHARS_COMMENT[i]); //text to show
    		availableCharsCombo.setData(""+i, SystemConstant.REG_CHARS[i]); //seq-RegChars
    		logger.debug("add availableChars: " 
    				+SystemConstant.REG_CHARS_COMMENT[i] +"-"+ SystemConstant.REG_CHARS[i]);
    	}
    	availableCharsCombo.select(0);//ѡһ
	}
    
    
	private String makeRegExp() {
		String result = null;
		String key = ""+ availableCharsCombo.getSelectionIndex();//ѡindexתַͣպÿΪkeyڲѯӦObject
		String chars = (String) availableCharsCombo.getData(key);
		
		//ļַ
		if(chars==null)
			return "";
		if(chars.equals(""))//Լvalueǿմֻһֿܣ"customize literal text..."
		{
			//valueҪԱtextؼûֵ
			String text = literalText.getText();//ȡûַ
			//TODO ֵ顢"."ȵ滻
			chars = Utils.StrToRegexp(text);
		}
		
		//γļ֣ţȻǶַ
		chars = addBracket(chars);//ַ
		
		//ִַ
		String amountStr = "";
		int min, max;
		// *+? ִη
		if(unlimitedButton.getSelection())//
		{
			min = spinnerMin.getSelection(); //maxֵ
			if(min==0)
			{
				amountStr = "*";//ʾ0-
			}
			else if(min==1)
			{
				amountStr = "+";//ʾ1-
			}
			else
			{
				amountStr = "{" +min+ ",}";//ʾminֵʼ-Σעⶺźûո
			}
			//ɽַ
			result = chars + amountStr;
		}//if,
		else //
		{
			//ȡminmaxֵ
			if(spinnerMin.getSelection()>=spinnerMax.getSelection())//minmaxֻȡеĴ
			{
				max = spinnerMin.getSelection();
				min = max;
			}
			else //ȡminmax
			{
				min = spinnerMin.getSelection();
				max = spinnerMax.getSelection();
			}
			logger.debug("min="+min+". max="+max);
			
			//ɽʽ
			if(min==max)//ȣ൱ڸȷĳִ
			{
				if(min!=1)//Ϊ1д"{n}"ʽ"{0}"ҲдμRegexBuddy
				{
					amountStr = "{" +min+ "}"; //дminдmax					
					result = chars + amountStr;
				}
				else //ֻһΣд"{1}"ǰַʹǶҲؼ(ַŵĽһ)ԻҪcharsߵȥ
				{
					if(chars.startsWith("(") && chars.endsWith(")")) //β()ֻǶַżӵģΪΪַͨȻ\( \)ʽ
					{
						result = chars.substring(1, chars.length()-1);
					}
					else //ûŵ(ַ)
					{
						result = chars;
					}
				}
			}
			else if(min==0 && max==1)//ȣΪ0-1Σɰ"{0,1}"дҲʹ"?"
			{
				amountStr = "?"; 	
				result = chars + amountStr;
			}
			else
			{
				amountStr = "{" +min+ "," +max+ "}"; 	
				result = chars + amountStr;
			}
		}//elseִ
		
		logger.debug("The regular expression result="+result);
		return result;
	}

	
	/** ַ */
	private String addBracket(String chars) {	
		if(chars.length()>1) 
		{
			//磺\\, \., \+ ֮Լ[a-z]֮Ϊһ岻
			if(chars.length()==2 && chars.startsWith("\\")
				|| (chars.startsWith("[") && chars.endsWith("]"))) 
			{}
			else
			{
				chars = "(" +chars+ ")";
			}
		}
		return chars;
	}

	
	private void initStatus() { 
		//ʼѡַб
		initTokenList();
//        //ʼʱ"next""finish"
//        setPageComplete(false);
	}
 

	/** 
	 * change "spinnerMax" status according to the "unlimited" button.
	 * */
	private void changeMaxStatus(boolean selected) {
		if(selected)
		{
			spinnerMax.setEnabled(false);
		}
		else
		{
			spinnerMax.setEnabled(true);
		}
	}
	
	
	/** 
	 * change customize textfield status according to the insertchar combo.
	 * */
	private void changeTextStatus(Combo charsCombo) {
		String key = ""+ charsCombo.getSelectionIndex();//ѡindexתַͣպÿΪkeyڲѯӦObject
		String value = (String) charsCombo.getData(key);
		if(value!=null && value.equals(""))//Լvalueǿմֻһֿܣ"customize literal text..."
		{
			literalText.setEnabled(true);
		}
		else
		{
			literalText.setEnabled(false);
		}
	}
	
	
	/**
	 * 
	 * */
	public String getContains()
	{
		return SystemConstant.REG_MATCH_PATTERNS[includes.getSelectionIndex()];
	}
	public String getFileName()
	{
		return fileName.getText();
	}
	public String getRegExp()
	{
		String result;
		//ûδ趨ļ֣ļΪ ".*" --ַ
		if(regExp.getText()==null  || regExp.getText().equals(""))
		{
			result = ".*";
		}
		else
		{
			result = regExp.getText();
		}
			
		String extKey = ""+extName.getSelectionIndex();//ѡindexתַͣպÿΪkeyڲѯӦObject
		String extChars = "(" +(String) extName.getData(extKey)+ ")"; 
		result += extChars; //һ 
		logger.debug("File pattern result="+result);
		
		//ļ֣չֲĽ
		return result;
	}
}