/**
 * @author: Ann
 * used in wizard , mainly in CreateTableWizard and ArchivingWizard
 * more files can be selected(file dialog and dir dialog)
 * CreateTableWizard MAY NEED TO CHOOSE INTERSET OR UNION? USE ANOTHER PAGE?
 */
package org.cvo.fithas.ui.wizard.headerarchiving;

import java.io.IOException;

import org.cvo.fithas.ui.wizard.MyWizardPage;
import org.cvo.fithas.util.ConfigHelper;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;

public class ScanTableSelectPage extends MyWizardPage {
	
	static org.cvo.fithas.util.Logger logger = new org.cvo.fithas.util.Logger(ScanTableSelectPage.class.getName () ) ;
	
	
    //radio buttons
    private Button Radio_file;
    private Button Radio_dir;
    
   
    
    /**
     * ̳иĹ캯
     */
    protected ScanTableSelectPage(String pageName) {
        super(pageName);
    }

    /*
     * дcreateControlڴ˷ﹹҳϵĽעⲻҪ
     * parentֱӴԪأӦһtopCompϴ
     */
    public void createControl(Composite parent) {
    	
        //һĵײ壬ʹGridLayout
        Composite topComp = new Composite(parent, SWT.NULL);
        topComp.setLayout(new GridLayout());
        topComp.setBounds(20,20,450,220);
        
        try {
	        //--------------file --------------------
	        Group fileGroup = new Group(topComp, SWT.NULL);
	        fileGroup.setLayoutData(new GridData(SWT.DEFAULT, 111));
	        fileGroup.setText(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.scanfilemode.fileGroup.label"));
	        fileGroup.setBounds(50,30,450, 60);
	         
	        /*------------ file part -------------------*/
	        //redio
	        Radio_file = new Button(fileGroup, SWT.RADIO);
	        Radio_file.setText(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.scanfilemode.files.label"));
	        Radio_file.setBounds(10, 36, 450, 30);
	        Radio_file.addSelectionListener(new SelectionAdapter() {
	        	public void widgetSelected(final SelectionEvent e) {
	        		enableFileMethod(true); //when clicked, enable file group and disable dir group 
	        		
	        	}
	        });
	
	       
	
	        
	        /*------------ dir part -------------------*/
	        //radio button of dir 
	        Radio_dir = new Button(fileGroup, SWT.RADIO);
	        Radio_dir.setText(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.scanfilemode.dir.label"));
	        Radio_dir.setBounds(10, 67, 450, 30);
	        Radio_dir.addSelectionListener(new SelectionAdapter() {
	        	public void widgetSelected(final SelectionEvent e) {
	        		enableFileMethod(false); //when clicked, enable dir group and disable file group 
	        		
	        	}
	        });
	
	       
	      
	        //init radio selection status
	        initStatus(); //enable file method
	        
	        //---ÿҳʾϢ---
			setTitle(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.scanfilemode.title"));
	        setMessage(ConfigHelper.getAttribute("ui.msg.wizard.batcharchive.scanfilemode.message"),
	        		INFORMATION);
	        
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

        //Ҫһ
        this.setControl(topComp);
       
        
    }


    private void initStatus() {
    	enableFileMethod(true);
        
    	
        //ʼʱ"next""finish"
        setPageComplete(true);
	}

    private void enableFileMethod(boolean enableFile)
    {
    	//radio buttons
        Radio_file.setSelection(enableFile);
        Radio_dir.setSelection(!enableFile);
        //enable file components 
       
    }
    


	
	/**
     * Զ巽ݱ仯ʱݵĺϷ
     */
   



    /*
     * --------Ӧset/get ---------------
     */

	/**
	 * @return Returns the fileText's value.
	 */
	
    
	
	
	public int getRadioSelection()
	{
		if(Radio_file.getSelection())
			return 0;
		else 
			return 1;
	}
	
	/**
	 * Judge whether method of "dir" is selected. 
	 * Used to further get data functions (to call getFile() or getDir()).
	 * */
	public boolean isDirSelected()
	{
		if(Radio_dir.getSelection())
			return true;
		else
			return false;
	}
	
}